;----------------------------------------------------------------
;	Visdom Demo by JAC!
; 
;	(c) 04-05-1991 by JL, re-version for the Visdom Party in NK !!!!
;	(r) 16-06-2007 by JAC!, added normal key detection to leave part I
;	(r) 16-06-2010 by JAC!, scroll text flash PM color corrected to $c0 in part II
;	(r) 17-08-2010 by JAC!, fader loader added, preparation for SuperPacker and NTSC
;	(r) 18-08-2010 by JAC!, NTSC fix completed, replay delay is now 6/50=0,12 in PAL and 7/60=0,1167 in NTSC
;	(r) 22-02-2012 by JAC!, pressing any key now leaves part 1 instead of pressing SELECT
;	(r) 13-03-2012 by JAC!, NTSC color mapping included
;
;	Press any key in the first part to continue.
;
;	Pack with SuperPacker. Main segment must be packed using Exomizer with
;	depack=$8000, buffer=$8100 and decrunch effect code "JSR $7F00".
;	After packing, insert the "Visdom-I-Decrunch.xex" before the 2nd INIT $2000 segement.

quote	= $22		;Constant_for_scroll_text

irqa	= $e0		;IRQ_temporaries
irqx	= $e1
irqy	= $e2
dliup	= $e3		;IRQ_counter

tp	= $f0		;Text_pointer
p1	= $f2		;Universal_pointers
p2	= $f4
p3	= $f6
x1	= $f8		;Universal_variables
x2	= $f9
x3	= $fa
cnt	= $ff		;Frame_counter

hotchr1	= $2000		;Multicolor_logo_charset
hotchr2	= $2400		;Hires_scroll_charset
pm	= $8000		;PM_graphics

base		= $a000
ctab		= base+$000	;128_colors_bar

vis_llo		= base+$100	;Line_lo_addresses
vis_lhi		= base+$101	;Line_hi_addresses
vis_stab1	= base+$200	;Scroll_tables
vis_stab2	= base+$300	;Scroll_tables
vis_stab3	= base+$400	;Scroll_tables
vis_stab4	= base+$500	;$d404_frame_values_($80)
vis_ftab1	= base+$580	;JL_background_color_($80)
vis_ftab2	= base+$600	;Visdom_background_color_($80)
vis_ftab3	= base+$680	;Visdom_color_($80)
vis_ftab4	= base+$700	;PM_color_($80)
vis_xtab	= base+$780	;Stars_HPOS_($80)
vis_xtab1	= base+$800	;Player_HPOS_($80)
vis_gtab	= base+$880	;Stars_speed_($80)
vis_rtab	= base+$900	;Raster_effect
vis_scrolline	= base+$a00	;Text_scroll_line

	.include "Macros.inc"

.bank
*	= $2000
;	.byte "0123456789012345678901234567890123456789"
	.byte 13,10,155
	.byte "Visdom Demo by JAC! of WUDSN",13,10,155
	.byte "Original version: 04-05-1991",13,10,155
	.byte "Fixed version   : 13-03-2012",13,10,155
	.byte 253,253,253,0

;==========================================================
; Pre-loader to fade the screen off
;==========================================================

.bank
.local
*	= $2000
init_loader
	jsr ?init_loader_system
	jsr ?init_loader_fade
	rts

; Check if this system has 64k. 
; If not wait for a key and cold start.
?init_loader_system
	lda #1
	sta 580	;Enforce cold start upon reset

	sei
	lda #0
	sta $d40e
	ldy #0
	lda $d301
	pha
	lda #$fe	;Disable OS ROM
	sta $d301
	ldx $e000	;Check if writeable
	inc $e000
	cpx $e000
	bne ?init_loader_system1
	iny		;No
?init_loader_system1
	pla
	sta $d301
	lda #$40
	sta $d40e
	cli
	cpy #0
	bne ?init_loader_fail_64k
	rts

?init_loader_fail_64k
	set init_loader_error_dl1,init_loader_error_sm2
	lda #14
	sta 708
	set $230,init_loader_error_dl
?init_loader_fail1
	clc
	lda 20
	adc $d40b
	sta $d40a
	sta $d01a
	lda $d20f
	and #12
	cmp #12
	beq ?init_loader_fail1
	jmp $e474
	
init_loader_error_dl
	.byte $70,$70,$70,$70,$70,$70,$70,$70,$70,$70,$70,$70
	.byte $47
init_loader_error_dl1
	.word init_loader_error_sm2
	.byte $70,$46
	.word init_loader_error_sm3
	.byte $41
	.word init_loader_error_dl

init_loader_error_sm2
	.sbyte "  REQUIRES 64K RAM. "
init_loader_error_sm3
	.sbyte "PRESS KEY TO REBOOT."

;----------------------------------------------------------------

?init_loader_fade
	lda #0
	sta x2
	ldx #8
?init_loader_fade2
	lda 704,x
	pha
	and #$f0
	sta x1
	pla
	and #15
	beq ?init_loader_fade3
	sec
	sbc #1
	ora x1
	sta x2
?init_loader_fade3
	sta 704,x
	dex
	bpl ?init_loader_fade2
	lda 20
	clc
	adc #2
?init_loader_fade4
	cmp 20
	bne ?init_loader_fade4
	lda x2
	bne ?init_loader_fade
	
	ldx #$1f		;Setup PM graphics for STX $D000 in the packer
?init_loader_fade5
	sta $d000,x
	dex
	bpl ?init_loader_fade5
	lda #$80
	sta $d00d
	lda #6
	sta 704
	sta $d012
	rts

.bank
*	= $2e2
	.word init_loader

.local

;----------------------------------------------------------------
;

.bank

*	= hotchr1
	.incbin "Visdom-I-Hotline.chr"

;----------------------------------------------------------------

*	= $2800	;Start of the main

start	jsr init_sound
	jsr start_part1
	jmp start_part2


;----------------------------------------------------------------

map_palette
	pha
	lda $d014
	and #2
	beq map_palette_pal	;It is already PAL.
	pla
	cmp #$10
	bcc map_palette_return
	cmp #$e0;		$0/E/F=>0/E/F,
	bcs map_palette_return
	adc #$10 		;$1..D => 2..D/1
	cmp #$e0
	bcc map_palette_return
	adc #$30-1
	rts
map_palette_pal
	pla
map_palette_return
	rts

;----------------------------------------------------------------
wait
	clc
	adc cnt
	cmp cnt
	bne *-2
	rts

;----------------------------------------------------------------
init_sound
	lda #0
	ldy #8			;reset_all
init_sound1
	sta $d200,y
	dey
	bpl init_sound1
	sta sndlst
	sta sndlst+1
	sta sndlst+2
	sta sndlst+3
	sta sndtaktup
	lda #1
	sta snddelay
	lda #3
	sta $d20f
	rts

;----------------------------------------------------------------
play_sound
	jsr play_pattern
	jmp play_channel

;----------------------------------------------------------------
play_channel
	cld
	ldx #4	;channel_number
	dec sndvip
play_channel1
	dex
	txa
	bmi play_channel5
	asl
	tay
	lsr
	lda sndr1c,x
	beq play_channel2
	lda sndr10,x
	beq play_channel2
	lda sndvip
	bne play_channel4
	lda sndr20,x
	adc sndr1c,x
	sta $d200,y
play_channel2
	inc sndlst,x
	lda sndlst,x
	cmp sndr08,x
	bne play_channel3
	lda sndr10,x
	beq play_channel3
	dec sndr10,x
	lda sndr10,x
	clc
	adc sndr0c,x
	sta $d201,y
	lda #$00
	sta sndlst,x
play_channel3
	lda sndflag
	beq play_channel1
	lda sndr00,x
	beq play_channel1
	lda sndr04,x
	sta sndr10,x
	lda #$00
	sta sndr00,x
	lda sndr14,x
	adc sndr0c,x
	sta $d201,y
	lda sndr18,x
	sta $d200,y
	sta sndr20,x
	lda sndr08,x
	sta sndlst,x
	dec sndlst,x
	jmp play_channel1
play_channel4
	lda sndr20,x
	sta $d200,y
	jmp play_channel2
play_channel5
	lda #0
	sta sndflag
	lda sndvip
	bne play_channel6
	lda #2
	sta sndvip
play_channel6
	rts

;----------------------------------------------------------------
;	x-register contains current takt
;	y-register contains current note

	.macro getnote
	lda %1,x
	sta %2
	asl
	asl
	asl
	asl
	clc
	adc #<%3
	sta %4+1
	lda #>%3
	adc #0
	sta %4+2
	.endm

play_pattern
	dec snddelay
	lda snddelay
	cmp #1
	bne play_pattern1
	sta sndflag

play_pattern1
	cmp #0
	beq play_pattern2
	rts

play_pattern2
	lda $d014	;Slow_down_replay_under_ntsc
	and #2
	lsr		;0_for_PAL,1_for NTSC
	clc
	adc #6
	sta snddelay

	ldx sndtaktup

	getnote sndtakt1,sndv1,sndnotes1,play_setnote1
	getnote sndtakt2,sndv2,sndnotes2,play_setnote2
	getnote sndtakt3,sndv3,sndnotes3,play_setnote3
	getnote sndtakt4,sndv4,sndnotes4,play_setnote4

	ldy sndnoteup

	lda sndv2
	ldx #2
	cmp #4
	bcc *+4
	ldx #1
	stx sndr08+1

	lda sndv4
	ldx #11
	cmp #10
	bcc *+4
	ldx #7
	stx sndr04+3

play_setnote1
	lda $ffff,y
	sta sndr18
play_setnote2
	lda $ffff,y
	sta sndr18+1
play_setnote3
	lda $ffff,y
	sta sndr18+2
play_setnote4
	lda $ffff,y
	sta sndr18+3

	ldx #3		;tune_on?
play_pattern3
	lda sndr18,x
	beq play_pattern4
	lda #1
	sta sndr00,x
play_pattern4
	dex
	bpl play_pattern3

	ldy sndnoteup
	iny
	cpy #16
	bne play_pattern5
	ldy #0
	ldx sndtaktup
	inx
	cpx #48
	bne *+4
	ldx #0
	stx sndtaktup
play_pattern5
	sty sndnoteup
	rts

;----------------------------------------------------------------

sndtaktup	.byte 0
sndnoteup	.byte 0
snddelay	.byte 0
sndv1		.byte 0
sndv2		.byte 0
sndv3		.byte 0
sndv4		.byte 0
sndlst		.byte 0,0,0,0	;4 bytes!
sndvip		.byte 0
sndflag		.byte 0

sndnotes1
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 50,0,0,0,30,0,50,0,50,0,0,0,30,0,50,0
	.byte 0,0,50,0,30,0,50,0,50,0,15,0,15,0,15,0
	.byte 0,0,50,0,30,0,50,0,50,0,15,15,0,15,15,15
	.byte 0,0,50,0,20,0,50,20,0,20,0,50,20,50,20,20

sndnotes2
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 81,0,40,0,81,0,40,0,81,0,40,0,81,0,40,0
	.byte 103,0,51,0,103,0,51,0,91,0,45,0,91,0,45,0
	.byte 123,0,61,0,123,0,61,0,91,0,45,0,91,0,45,0
	.byte 48,81,40,81,40,81,40,40,81,81,40,81,40,81,81,81
	.byte 51,103,51,51,51,103,51,103,103,103,51,103,51,103,103,103
	.byte 91,45,45,91,45,91,45,45,91,91,45,91,45,45,91,45
	.byte 111,111,55,111,55,111,55,55,111,55,55,111,55,111,111,111

sndnotes3
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 102,0,153,0,128,0,153,102,0,102,153,0,128,0,153,0
	.byte 96,0,153,0,128,0,96,114,0,114,128,0,136,0,128,0
	.byte 96,0,153,0,128,0,96,114,0,0,0,0,0,0,0,0
	.byte 0,0,204,0,173,0,153,0,136,136,0,153,0,153,173,0
	.byte 0,0,153,0,128,0,114,0,102,102,0,114,0,114,128,0
	.byte 0,0,173,0,136,0,128,0,114,114,0,128,0,128,136,0
	.byte 0,0,193,0,153,0,136,0,128,128,0,136,0,136,153,0
	.byte 96,0,96,0,0,0,96,0,96,0,96,0,102,0,102,0
	.byte 114,0,114,0,0,0,114,0,114,0,114,0,102,0,0,0
	.byte 96,0,96,0,0,0,96,0,96,0,96,0,85,0,0,0
	.byte 114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

sndnotes4
	.byte 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 37,0,0,0,42,0,37,0,0,0,50,0,37,0,33,0
	.byte 31,0,0,0,28,0,33,0,0,0,42,0,31,0,33,0
	.byte 57,0,0,0,31,0,33,0,0,0,0,0,0,0,0,0
	.byte 37,0,0,0,42,0,37,0,0,0,50,0,37,0,42,0
	.byte 37,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0
	.byte 47,0,0,0,37,0,0,0,31,0,0,0,23,0,0,0
	.byte 28,0,0,0,0,0,0,0,0,0,0,0,42,0,0,0
	.byte 50,0,0,0,42,0,0,0,33,0,0,0,42,0,0,0
	.byte 37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.byte 173,0,193,0,204,0,230,173,0,173,193,0,204,0,230,0

sndtakt1	.byte 1,2,1,2,1,3,1,2,1,3,1,2,1,3,1,2,1,3,1,2,1,3,1,2,1,3,1,2,1,3,1,3,1,2,1,4,1,2,1,3,1,2,1,3,1,2,1,3
sndtakt2	.byte 0,0,1,2,1,3,1,2,1,3,1,2,1,3,1,2,1,3,4,5,6,7,4,5,6,7,4,5,6,7,0,0,5,6,5,6,5,6,5,6,0,0,0,0,1,2,1,3
sndtakt3	.byte 0,0,0,0,0,0,1,2,1,3,1,2,1,3,1,2,1,3,0,0,0,4,0,0,0,4,5,7,6,4,0,0,8,9,10,11,8,9,10,11,1,2,1,3,1,2,1,3
sndtakt4	.byte 0,0,0,0,0,0,0,0,0,0,1,2,4,3,1,2,4,3,0,0,0,0,5,6,7,8,5,6,7,8,9,0,0,0,0,0,10,10,10,0,1,2,4,3,1,2,4,3

sndr00	.byte $00,$00,$00,$00
sndr04	.byte $0b,$08,$0c,$0b
sndr08	.byte $01,$02,$01,$03
sndr0c	.byte $80,$c0,$a0,$a0
sndr10	.byte $00,$00,$00,$00
sndr14	.byte $0e,$0e,$0e,$0e
sndr18	.byte $00,$00,$00,$00
sndr1c	.byte $04,$00,$00,$00
sndr20	.byte $00,$00,$00,$00

start_part1
	.include "Visdom-I-Hotline.asm"

start_part2
	.include "Visdom-I-Part2.asm"
	
.bank
*	= $2e0
	.word start
